#define IMGUI_DISABLE_INCLUDE_IMCONFIG_H
#define IMGUI_HAS_DOCK 1

#include "GameInformations.h"
#include "GameFixes.h"
#include "inicpp.h"
#include <imgui.h>
#include <reshade.hpp>
#include <string>
#include <Windows.h>

// Screen informations
static int screenWidth = GetSystemMetrics(SM_CXSCREEN);
static int screenHeight = GetSystemMetrics(SM_CYSCREEN);
static float aspectRatio = (float)screenWidth / screenHeight;

// Core game dll functions declarations
typedef void (*SetBoolFn)(bool, bool);
typedef void (*SetFixesFn)(GameFixes ,bool);
typedef void (*SetIntFn)(int);
typedef void (*SetFloatFn)(float);

static HMODULE fixLib = nullptr;
static LONG g_coreInitialized = 0;
static SetBoolFn SetFixEnabled = nullptr;
static SetFixesFn SetFixesEnabled = nullptr;
static SetIntFn SetFOV = nullptr;
static SetIntFn SetCinematicsFOV = nullptr;
static SetFloatFn SetCameraDistance = nullptr;
static SetFloatFn SetSharpening = nullptr;
static GetGameInfosStruct GetGameInfos = nullptr;

// Plugin variables for checkboxes and sliders
static bool fov_fix_enabled = false;
static bool ultrawide_fix_enabled = false;
static bool camera_fix_enabled = false;
static bool DOF_fix_enabled = false;
static bool Vignetting_fix_enabled = false;
static bool Fog_fix_enabled = false;
static bool Volumetricfog_fix_enabled = false;
static bool Sharpening_fix_enabled = false;
static bool fix_enabled = false;
static bool console = true;
static int worldFOVvalue = 0;
static int cinematicsFOVvalue = 0;
static float sharpeningvalue = 1.f;
static float cameraDistancevalue = 1.f;

// Overlays popups
static bool popup_Informations = false;
static bool show_log_overlay = false;
static std::string log_content;

// Plugin settings
const std::string SETTINGS_FILE = "./pluginsettings.ini";
const char* FIX_VERSION = "1.0.1";
const char* FIX_INFORMATIONS = "This fix allows to:\n - Control FOVs in game.\n - Enable ultrawide.\n - Control camera distance.\n - Disable depth of field.\n - Disable vignetting.\n - Disable fog.\n - Re enable dev console.";
const char* DONATION_URL = "https://buymeacoffee.com/k4sh44";

// Scaling factor based on screen resolution
float scale = (float)screenHeight / 1200;

// Reshade addon name and description
extern "C" __declspec(dllexport) const char* NAME = "Star Wars Jedi: Survivor";
extern "C" __declspec(dllexport) const char* DESCRIPTION = "Reshade addon to re-enable console, enable ultrawide, control FOVs, camera distance and some effects.";

// Load and unload game core dll functions /!\ necessary
static void LoadFixDLL()
{
    // Ensure the Core dll will be called once
    if (InterlockedCompareExchange(&g_coreInitialized, 1, 0) != 0)
        return;

    if (GetModuleHandleA("JediSurvivorCore.dll") == nullptr) {
        fixLib = LoadLibraryA("JediSurvivorCore.dll");

        if (!fixLib) {
            MessageBoxA(nullptr, "Impossible to load game core dll", "Erreur", MB_OK);
            return;
        }

        SetFixEnabled = (SetBoolFn)GetProcAddress(fixLib, "SetFixEnabled");
        SetFixesEnabled = (SetFixesFn)GetProcAddress(fixLib, "SetFixesEnabled");
        SetFOV = (SetIntFn)GetProcAddress(fixLib, "SetFOV");
        SetCinematicsFOV = (SetIntFn)GetProcAddress(fixLib, "SetCinematicsFOV");
        SetCameraDistance = (SetFloatFn)GetProcAddress(fixLib, "SetCameraDistance");
        SetSharpening = (SetFloatFn)GetProcAddress(fixLib, "SetSharpening");
        GetGameInfos = (GetGameInfosStruct)GetProcAddress(fixLib, "GetGameInfos");

        // Apply initial values loaded from settings
        if (SetFOV) SetFOV(worldFOVvalue);
        if (SetCameraDistance) SetCameraDistance(cameraDistancevalue);
        if (SetFixEnabled) SetFixEnabled(fix_enabled, true);
        if (SetFixesEnabled) {
            SetFixesEnabled(GameFixes::FOV, fov_fix_enabled);
            SetFixesEnabled(GameFixes::UltraWide, ultrawide_fix_enabled);
            SetFixesEnabled(GameFixes::Camera, camera_fix_enabled);
            SetFixesEnabled(GameFixes::DOF, DOF_fix_enabled);
            SetFixesEnabled(GameFixes::Vignetting, Vignetting_fix_enabled);
            SetFixesEnabled(GameFixes::Fog, Fog_fix_enabled);
            SetFixesEnabled(GameFixes::VolumetricFog, Volumetricfog_fix_enabled);
            SetFixesEnabled(GameFixes::Sharpening, Sharpening_fix_enabled);
            SetFixesEnabled(GameFixes::DevConsole, console);
        }
    }
}

// Settings functions
static void SaveSettings()
{
    ini::IniFile pluginIniFile;
    pluginIniFile["1#General fix"].setComment(std::vector<std::string>{ "The following sections are saved by plugin",
                                                                        "You should not need to modify them",
                                                                        " ",
                                                                        "Controls if fix mod (globally) is enabled",
                                                                        "Set Console to false if you don't want dev console to be enabled"});
    pluginIniFile["1#General fix"]["Enabled"] = fix_enabled;
    pluginIniFile["1#General fix"]["Console"] = console;
    pluginIniFile["2#Individual fix"].setComment("Controls each fix individually");
    pluginIniFile["2#Individual fix"]["FOV"] = fov_fix_enabled;
    pluginIniFile["2#Individual fix"]["UltraWide"] = ultrawide_fix_enabled;
    pluginIniFile["2#Individual fix"]["Camera"] = camera_fix_enabled;
    pluginIniFile["2#Individual fix"]["Sharpening"] = Sharpening_fix_enabled;
    pluginIniFile["2#Individual fix"]["DOF"] = DOF_fix_enabled;
    pluginIniFile["2#Individual fix"]["Vignetting"] = Vignetting_fix_enabled;
    pluginIniFile["2#Individual fix"]["Fog"] = Fog_fix_enabled;
    pluginIniFile["2#Individual fix"]["Volumetric fog"] = Volumetricfog_fix_enabled;
    pluginIniFile["3#Fixes tuning"].setComment("Individual fix fine tune");
    pluginIniFile["3#Fixes tuning"]["World FOV"] = worldFOVvalue;
    pluginIniFile["3#Fixes tuning"]["Cinematics FOV"] = cinematicsFOVvalue;
    pluginIniFile["3#Fixes tuning"]["Sharpening"] = sharpeningvalue;
    pluginIniFile["3#Fixes tuning"]["Camera distance"] = cameraDistancevalue;

    pluginIniFile.save(SETTINGS_FILE);
}

static void LoadSettings()
{
    ini::IniFile pluginIniFile;
    try {
        pluginIniFile.load(SETTINGS_FILE);
        fix_enabled                 = pluginIniFile["1#General fix"]["Enabled"].as<bool>();
        console                     = pluginIniFile["1#General fix"]["Console"].as<bool>();
        fov_fix_enabled             = pluginIniFile["2#Individual fix"]["FOV"].as<bool>();
        ultrawide_fix_enabled       = pluginIniFile["2#Individual fix"]["UltraWide"].as<bool>();
        camera_fix_enabled          = pluginIniFile["2#Individual fix"]["Camera"].as<bool>();
        Sharpening_fix_enabled      = pluginIniFile["2#Individual fix"]["Sharpening"].as<bool>();
        DOF_fix_enabled             = pluginIniFile["2#Individual fix"]["DOF"].as<bool>();
        Vignetting_fix_enabled      = pluginIniFile["2#Individual fix"]["Vignetting"].as<bool>();
        Fog_fix_enabled             = pluginIniFile["2#Individual fix"]["Fog"].as<bool>();
        Volumetricfog_fix_enabled   = pluginIniFile["2#Individual fix"]["Volumetric fog"].as<bool>();
        worldFOVvalue               = pluginIniFile["3#Fixes tuning"]["World FOV"].as<int>();
        cinematicsFOVvalue          = pluginIniFile["3#Fixes tuning"]["Cinematics FOV"].as<int>();
        sharpeningvalue             = pluginIniFile["3#Fixes tuning"]["Sharpening"].as<float>();
        cameraDistancevalue         = pluginIniFile["3#Fixes tuning"]["Camera distance"].as<float>();
    }
    catch (const std::exception& e) {}
}

// Read plugin log file
void read_log_file(const std::string& filename) {
    std::ifstream file(filename);
    if (!file.is_open())
    {
        log_content = "Impossible to open file : " + filename;
        return;
    }

    std::ostringstream ss;
    ss << file.rdbuf();
    log_content = ss.str();
}

// Initialize ImGui widgets for Reshade
static void on_overlay_draw(reshade::api::effect_runtime* runtime)
{
    ImGuiStyle& style = ImGui::GetStyle();
    style.ItemSpacing = ImVec2(8 * scale, 8 * scale);     // Spacing between widgets
    style.FramePadding = ImVec2(3 * scale, 3 * scale);    // Widgets padding
    style.WindowPadding = ImVec2(10 * scale, 10 * scale); // Overlay padding
    style.CellPadding = ImVec2(10 * scale, 10 * scale);   // Table cells padding

    ImGui::SetNextWindowSize(ImVec2(350 * scale, 150 * scale), ImGuiCond_Once);

    ImGui::PushStyleColor(ImGuiCol_Button, ImVec4(0.84f, 0.12f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_ButtonHovered, ImVec4(0.84f, 0.12f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_ButtonActive, ImVec4(0.84f, 0.2f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_Text, ImVec4(0.8f, 1.f, 1.f, 1.f)); // white
    if (ImGui::Button("Like my work ? Consider donation")) ShellExecuteA(NULL, "open", DONATION_URL, NULL, NULL, SW_SHOWNORMAL); // Donation
    ImGui::PopStyleColor(4); // Restore color
    ImGui::SameLine();
    if (ImGui::Button("Fix informations")) popup_Informations = true; // Fix information
    ImGui::SameLine();
    if (ImGui::Button("View logs")) {
        read_log_file("JediSurvivor.log");
        show_log_overlay = true; // Fix information
    }

    if (popup_Informations)
    {
        ImGui::Begin("Informations", &popup_Informations, ImGuiWindowFlags_AlwaysAutoResize);
        ImGui::Text("Version : %s", FIX_VERSION);
        ImGui::Text(FIX_INFORMATIONS);
        ImGui::End();
    }

    if (show_log_overlay)
    {
        ImGui::Begin("Game log", &show_log_overlay, ImGuiWindowFlags_AlwaysAutoResize);
        ImGui::TextUnformatted(log_content.c_str());
        ImGui::End();
    }

    ImGui::PushStyleVar(ImGuiStyleVar_CellPadding, ImVec2(10 * scale, 10 * scale));
    if (ImGui::BeginTable("FixesTable", 2, ImGuiTableFlags_SizingStretchSame)) {
        ImGui::TableSetupColumn("LeftFix", ImGuiTableColumnFlags_WidthStretch, 0.4f);
        ImGui::TableSetupColumn("RightFix", ImGuiTableColumnFlags_WidthStretch, 0.6f);
        ImGui::TableNextRow();

        // Drawing a left column with slider and general fix
        ImGui::TableSetColumnIndex(0);
        if (ImGui::CollapsingHeader("Enable fixes", ImGuiTreeNodeFlags_DefaultOpen))
            if (ImGui::Checkbox("Fix enabled", &fix_enabled)) {
                if (SetFixEnabled) SetFixEnabled(fix_enabled, false);
                SaveSettings();
            }

        // Individual fixes
        ImGui::TableSetColumnIndex(1);
        if (ImGui::CollapsingHeader("Individual fixes", ImGuiTreeNodeFlags_DefaultOpen)) {
            if (ImGui::BeginTable("IndividualFixesTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableSetupColumn("IndFix1", ImGuiTableColumnFlags_WidthStretch, 0.4f);
                ImGui::TableSetupColumn("IndFix2", ImGuiTableColumnFlags_WidthStretch, 0.6f);
                ImGui::TableNextRow();

                ImGui::TableSetColumnIndex(0);
                if (ImGui::Checkbox("FOVs", &fov_fix_enabled)) {
                    if (SetFixesEnabled) SetFixesEnabled(GameFixes::FOV, fov_fix_enabled);
                    SaveSettings();
                }

                if (ImGui::Checkbox("Vignetting", &Vignetting_fix_enabled)) {
                    if (SetFixesEnabled) SetFixesEnabled(GameFixes::Vignetting, Vignetting_fix_enabled);
                    SaveSettings();
                }

                if (ImGui::Checkbox("Sharpening", &Sharpening_fix_enabled)) {
                    if (SetFixesEnabled) SetFixesEnabled(GameFixes::Sharpening, Sharpening_fix_enabled);
                    SaveSettings();
                }

                if (ImGui::Checkbox("Fog", &Fog_fix_enabled)) {
                    if (SetFixesEnabled) SetFixesEnabled(GameFixes::Fog, Fog_fix_enabled);
                    SaveSettings();
                }
                if (ImGui::IsItemHovered()) {
                    ImGui::BeginTooltip();
                    ImGui::Text("This fix will disable all fogs including volumetric fog.");
                    ImGui::EndTooltip();
                }

                ImGui::TableSetColumnIndex(1);
                if (ImGui::Checkbox("Ultrawide", &ultrawide_fix_enabled)) {
                    if (SetFixesEnabled) SetFixesEnabled(GameFixes::UltraWide, ultrawide_fix_enabled);
                    SaveSettings();
                }

                ImGui::TableSetColumnIndex(1);
                if (ImGui::Checkbox("Camera distance", &camera_fix_enabled)) {
                    if (SetFixesEnabled) SetFixesEnabled(GameFixes::Camera, camera_fix_enabled);
                    SaveSettings();
                }

                if (ImGui::Checkbox("Depth of field", &DOF_fix_enabled)) {
                    if (SetFixesEnabled) SetFixesEnabled(GameFixes::DOF, DOF_fix_enabled);
                    SaveSettings();
                }

                if (ImGui::Checkbox("Volumetric fog", &Volumetricfog_fix_enabled)) {
                    if (SetFixesEnabled) SetFixesEnabled(GameFixes::VolumetricFog, Volumetricfog_fix_enabled);
                    SaveSettings();
                }
                ImGui::EndTable();
            }
        }
        ImGui::EndTable();

        if (ImGui::BeginTable("SlidersTable", 2, ImGuiTableFlags_SizingStretchSame)) {
            ImGui::TableSetupColumn("LeftSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
            ImGui::TableSetupColumn("RightSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
            ImGui::TableNextRow();
            ImGui::TableSetColumnIndex(0);
            if (ImGui::CollapsingHeader("In game additional FOV", ImGuiTreeNodeFlags_DefaultOpen))
            {
                ImGui::SetNextItemWidth(180 * scale);
                if (ImGui::SliderInt("##FOVValue", &worldFOVvalue, -20, 50)) {
                    if (SetFOV) SetFOV(worldFOVvalue);
                    SaveSettings();
                }
            }

            if (ImGui::CollapsingHeader("Camera distance (*)", ImGuiTreeNodeFlags_DefaultOpen))
            {
                ImGui::SetNextItemWidth(200 * scale);
                if (ImGui::SliderFloat("##CameraValue", &cameraDistancevalue, 0, 2, "%.2f")) {
                    if (SetCameraDistance) SetCameraDistance(cameraDistancevalue);
                    SaveSettings();
                }
            }
            if (ImGui::IsItemHovered()) {
                ImGui::BeginTooltip();
                ImGui::Text("Value is a multiplier.");
                ImGui::EndTooltip();
            }

            ImGui::TableSetColumnIndex(1);
            if (ImGui::CollapsingHeader("Cinematics FOV", ImGuiTreeNodeFlags_DefaultOpen))
            {
                ImGui::SetNextItemWidth(180 * scale);
                if (ImGui::SliderInt("##CinematicsFOVValue", &cinematicsFOVvalue, -20, 50)) {
                    if (SetCinematicsFOV) SetCinematicsFOV(cinematicsFOVvalue);
                    SaveSettings();
                }
            }

            if (ImGui::CollapsingHeader("Image sharpening", ImGuiTreeNodeFlags_DefaultOpen))
            {
                ImGui::SetNextItemWidth(200 * scale);
                if (ImGui::SliderFloat("##SharpeningValue", &sharpeningvalue, 0, 10, "%.1f")) {
                    if (SetSharpening) SetSharpening(sharpeningvalue);
                    SaveSettings();
                }
            }
            ImGui::EndTable();
        }
    }
    ImGui::PopStyleVar();
    // Fix status
    if (ImGui::CollapsingHeader("Fix informations", ImGuiTreeNodeFlags_DefaultOpen)) {
        ImGui::Text("Screen width: %d, height: %d, aspect ratio: %.2f", screenWidth, screenHeight, aspectRatio);
        if (GetGameInfos) {
            GameInfos infos{};
            GetGameInfos(&infos);
            if (infos.consoleEnabled)
                ImGui::Text("Console enabled and bound to key F2");
            ImGui::TextColored(ImColor(48, 179, 25), "FOV In: %.2f, Out: %.2f", infos.FOVIn, infos.FOVOut);
        }
    }
}

// Main dll intrance
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD ul_reason_for_call, LPVOID)
{
    switch (ul_reason_for_call)
    {
        case DLL_PROCESS_ATTACH:
            if (!reshade::register_addon(hinstDLL))
                return FALSE;
            LoadSettings();

            reshade::register_overlay("Star Wars Jedi: Survivor", &on_overlay_draw);
            reshade::register_event<reshade::addon_event::init_effect_runtime>(
                [](reshade::api::effect_runtime* runtime) {
                    LoadFixDLL();
                });
            break;
        case DLL_PROCESS_DETACH:
            reshade::unregister_addon(hinstDLL);
            break;
    }
    return TRUE;
}